<?php
/**
 * classe d'utilisation de l'API Google Analytics
 * PHP Versions > 5
 * recquiert	cUrl activ
 *
 * @author	Jean-Franois Lpine	<lepinejeanfrancois@yahoo.fr>
 * @date	Avril 2009
 *
 * utilisation :
 *
 * Google_Analytics::set('account_id'	, 'account_id' );	// compte concern
 * Google_Analytics::authentificate();				// connexion
 * $res = Google_Analytics::call($url);			// effectuer une requete
 */
abstract class Google_Analytics {

	private static $_var = array();	// espace de stockage pour les variables. 

	
	/**
	  * authentifier l'utilisateur
	  * la mthode va chercher si il y a un token dfini
	  * sinon, elle va tenter d'en dterminer un :
	  *	soit il y a un token dans la session
	  *	soit il n'y a aucun token	=> redirection vers la page de login de Google
	  *	soit il y a dj un token  usage unique	=> transormation du token en token  usage multiple
	  */
	public static function authentificate() {
	
		if( !self::get('token')) {
		
			//
			// rechercher dans session
			if( isset($_SESSION['token']) ) {
				self::set('token', $_SESSION['token'] );
				return;
			}
			
			//
			// premier affichage :
			if( !self::get('single_use_token') ) {
				
				//
				// pas de token en GET, le demander
				if( !isset($_GET['token']) ) {
					self::login( self::get('base_url') );
				} else {
				//
				// token en GET, le rendre permanent
					self::set( 'single_use_token', strip_tags($_GET['token']) );
					self::setPermanentToken();
				}
			}
		}
	}
	
	
	/**
	 * appeler la page de connexion
	 * l'utilisateur sera redirig vers le site Google, puis redirig vers la page indique
	 */
	public static function login() {
		$url		='https://www.google.com/accounts/AuthSubRequest?'
		. '&next='.$urlRetour
		. '&scope=https://www.google.com/analytics/feeds/'
		. '&secure=0'
		. '&session=1';
		
		header("Location: $url");
		exit;
	}
	
	
	/**
	 * transformer un jeton  usage unique en un jeton  usage multiple
	 */
	public static function setPermanentToken() {
		
		$url		=	'http://www.google.com/accounts/AuthSubSessionToken';
		$token 		=	 self::call($url);
		
		//
		// extraire le token
		$token		= str_ireplace('Token=', '', $token);
		self::set('token', $token);
		
		//
		// stocker en session
		if(isset($_SESSION)) {
			$_SESSION['token']	= $token;
		}
		
	}
	
	
	/**
	 * effectuer une requete cUrl chez google
	 * @param	string	requete
	 * @return	xml	/ gnre une erreur
	 */
	public static function call($url) {
	
		//
		// choix du token  utiliser
		$token	= self::get('token');
		if(!$token)	$token	= self::get('single_use_token');
		
		//
		// entte  envoyer
		$headers	= array(
			sprintf("Authorization: AuthSub token=\"%s\"/n", $token ),
			//sprintf("X-Google-Key: key=\"%s\"/n", self::get('key') )	// au cas o, utilisez ici votre developer key Google
		);
		
		//
		// Requete cUrl
		$ch = curl_init($url);
		$options = array(
			CURLOPT_RETURNTRANSFER	=> true,		// renvoie une page web
			CURLOPT_HEADER			=> false,		// ne renvoie pas d'en-tte
			CURLOPT_HTTPHEADER		=> $headers,	// en-ttes  envoyer
			CURLOPT_FOLLOWLOCATION	=> true,		// suivre les redirections
			CURLOPT_ENCODING		=> "",			// tout encodage possible
			CURLOPT_USERAGENT		=> "spider",	// nom de l'agent
			CURLOPT_AUTOREFERER		=> true,		// set referer on redirect
			CURLOPT_CONNECTTIMEOUT	=> 120,			// timeout on connect
			CURLOPT_TIMEOUT			=> 120,			// timeout on response
			CURLOPT_MAXREDIRS		=> 10,			// stop after 10 redirects
			CURLOPT_SSL_VERIFYHOST	=> 0,			// ne pas vrifier le SSL
			CURLOPT_SSL_VERIFYPEER	=> false,		// ne pas vrifier le SSL
			CURLOPT_VERBOSE			=> 1             //
		); 
		curl_setopt_array($ch,$options);
		
		//
		// Reponse cUrl
		$content = curl_exec($ch);
		$err     = curl_errno($ch);
		$errmsg  = curl_error($ch) ;
		$resp	 = curl_getinfo($ch); 
		curl_close($ch);
		
		//
		// Erreur : le code 200 n'est pas envoy
		if($resp['http_code'] != '200') {
			echo '<strong>Impossible d\'effectuer la requete : '.$content.'</strong><p><pre>';
			print_r($resp);
			print_r($headers);
			echo '</pre></p>';
			exit;
		}
		
		//
		// renvoyer le contenu
		return $content;
	}
	
	/**
	 * getters and setters
	 */
	public function set($var, $value) { self::$_var[$var]	= $value; }
	public function get($var) { if(!isset(self::$_var[$var])) return false; return self::$_var[$var]; }
}
?>